/****************************************************************************

COPYRIGHT NOTICE:

  The source code in this directory is provided free of
  charge to anyone who wants it.  It is in the public domain
  and therefore may be used by anybody for any purpose.  It
  is provided "AS IS" with no warranty of any kind
  whatsoever.  For further details see the README files in
  the wnlib parent directory.

AUTHOR:

  Will Naylor

****************************************************************************/
#ifndef wnrootH
#define wnrootH


#include "wnlib.h"


EXTERN void wn_findroot_raw_bracketed
(
  int *pcode,
  FLOAT *pf0,
  FLOAT *pf1,
  FLOAT *pf2,
  FLOAT *px0,
  FLOAT *px1,
  FLOAT *px2,
  FLOAT (*pfunction)(FLOAT x),
  int max_iterations
);

EXTERN void wn_findroot_bracketed
(
  int *pcode,
  FLOAT *px1,
  FLOAT *pf1,
  FLOAT x0,
  FLOAT f0,
  FLOAT x2,
  FLOAT f2,
  FLOAT (*pfunction)(FLOAT x),
  int max_iterations
);

EXTERN void wn_findroot
(
  int *pcode,
  FLOAT *px1,
  FLOAT *pf1,
  FLOAT x0,
  FLOAT f0,
  FLOAT x2,
  FLOAT f2,
  FLOAT (*pfunction)(FLOAT x),
  int max_iterations
);


EXTERN void wn_findroot_stop(void);

EXTERN void wn_findroot_getrange
(
  bool *pbracketed,
  FLOAT *px0,
  FLOAT *pf0,
  FLOAT *px2,
  FLOAT *pf2
);

#endif

