NAME
     wnhtbl -- make hash tables for common kinds of keys

SYNOPSIS
     #include "wnhtbl.h"

     wn_mkhashhtab(&table)
     wn_htab table;

     wn_mkstrhtab(&table)
     wn_htab table;

     wn_mkptrhtab(&table)
     wn_htab table;

     wn_mklonghtab(&table)
     wn_htab table;

DESCRIPTION
     Note that although these tables use different types of keys, they all
     use the same type of data -- wn_hget() always returns a ptr through
     the first argument.  It is very important that you not pass "&i" where
     i is an int to the first arg of wn_hget(), because on some architectures
     the object returned, a ptr, will be bigger than i and will overwrite
     memory after i.

     "wn_mkhashhtab" allocates a hash table that assumes the key
     is already hashed (from the current memory group).

     "wn_mkstrhtab" allocates a hash table indexed by null-terminated char
     strings (from the current memory group).

     "wn_mkptrhtab" allocates a hash table indexed by pointer keys, that
     is, by the value of the pointer itself (as opposed to what the
     pointer points to).

EXAMPLES
  
DIAGNOSTICS
  
BUGS

SEE ALSO
     wnhtab, wnhash, wncpy

AUTHOR
     Will Naylor

