/****************************************************************************

COPYRIGHT NOTICE:

  The source code in this directory is provided free of
  charge to anyone who wants it.  It is in the public domain
  and therefore may be used by anybody for any purpose.  It
  is provided "AS IS" with no warranty of any kind
  whatsoever.  For further details see the README files in
  the wnlib parent directory.

AUTHOR:

  Will Naylor

****************************************************************************/
#ifndef wnmatH
#define wnmatH


EXTERN void wn_print_mat(FLOAT **mat,int len_i,int len_j);
EXTERN void wn_enter_mat(FLOAT **mat,int len_i,int len_j);

EXTERN void wn_random_mat(FLOAT **mat,int len_i,int len_j);
EXTERN void wn_zero_mat(FLOAT **mat,int len_i,int len_j);
EXTERN void wn_identity_mat(FLOAT **mat,int len);
EXTERN void wn_hilbert_mat(FLOAT **mat,int len);

EXTERN void wn_make_mat(FLOAT ***pmat,int len_i,int len_j);
EXTERN void wn_free_mat(FLOAT **mat,int len_i,int len_j);

EXTERN void wn_copy_mat(FLOAT **to_mat,FLOAT **from_mat,int len_i,int len_j);
EXTERN void wn_transpose_mat(FLOAT **to_mat,FLOAT **from_mat,int len_i,int len_j);

EXTERN
void wn_mult_mat_by_vect(FLOAT *result_vect,FLOAT **mat,FLOAT *vect,
			 int len_i,int len_j);
EXTERN
void wn_mult_mats(FLOAT **result_mat,FLOAT **mat1,FLOAT **mat2,
		  int len_i,int len_j,int len_k);

EXTERN void wn_gramm_schmidt(int *pcode,FLOAT **mat,int len_i,int len_j);
EXTERN void wn_invert_mat(int *pcode,FLOAT **mat,int len_i);
EXTERN void wn_polish_inverse_mat
(
  int *pcode,
  FLOAT **mat_inverse,
  FLOAT **mat,
  int len,
  int iterations
);
EXTERN void wn_solve_system
(
  int *pcode,
  FLOAT *solution,
  FLOAT *rhs,
  FLOAT **mat_inverse,
  FLOAT **mat,
  int len,
  int iterations
);

EXTERN void wn_simplex_loop
(
  int *pcode,
  FLOAT **mat,                /* mat[len_i][len_j] */
  FLOAT *right_side,          /* right_side[len_i] */
  FLOAT *right_side_control,  /*right_side_control[len_i] */
  int *non_zero_vars,          /* non_zero_vars[len_i] */
  int *zero_vars,              /* zero_vars[len_j]  */
  int len_i,
  int len_j
);
EXTERN void wn_simplex_method
(
  int *pcode,
  FLOAT *pobjective,
  FLOAT *raw_shadow_prices,
  FLOAT *raw_solution,
  FLOAT *raw_objective_vect,
  FLOAT **raw_mat,
  FLOAT *raw_right_side,
  int len_i,
  int len_j
);

EXTERN void wn_svd
(
  FLOAT **image_basis,  /* image_basis[len_i][len_i] */
  FLOAT *d,             /* d[min(len_i, len_j)] */
  FLOAT **arg_basis,    /* arg_basis[len_j][len_j] */
  FLOAT **in_mat,       /* in_mat[len_i][len_j] */
  int len_i,             /* dimension of matrix **a */
  int len_j  
);


#endif

