/****************************************************************************

COPYRIGHT NOTICE:

  The source code in this directory is provided free of
  charge to anyone who wants it.  It is in the public domain
  and therefore may be used by anybody for any purpose.  It
  is provided "AS IS" with no warranty of any kind
  whatsoever.  For further details see the README files in
  the wnlib parent directory.

AUTHOR:

  Will Naylor

****************************************************************************/
#ifndef wnrnddH
#define wnrnddH


#include "wnlib.h"


EXTERN bool wn_true_with_probability(FLOAT prob);

EXTERN int wn_random_int_between(int low,int high);
EXTERN FLOAT wn_random_double_between(FLOAT low,FLOAT high);
EXTERN FLOAT wn_flat_distribution(void);

EXTERN FLOAT wn_arbitrary_distribution
(
  FLOAT (*pinverse_integral_density_func)(FLOAT integrated_prob)
);
EXTERN FLOAT wn_normal_distribution(void);
EXTERN void wn_normal_distribution_2vals(FLOAT *pval1, FLOAT *pval2);
EXTERN void wn_normal_distribution_2vals_slow(FLOAT *pval1, FLOAT *pval2);
EXTERN FLOAT wn_exponential_distribution(void);
EXTERN int wn_poisson_distribution(FLOAT mean);
EXTERN FLOAT wn_cauchy_distribution(void);


#endif

