/****************************************************************************

COPYRIGHT NOTICE:

  The source code in this directory is provided free of
  charge to anyone who wants it.  It is in the public domain
  and therefore may be used by anybody for any purpose.  It
  is provided "AS IS" with no warranty of any kind
  whatsoever.  For further details see the README files in
  the wnlib parent directory.

AUTHOR:

  Will Naylor

****************************************************************************/
#ifndef wnvectH
#define wnvectH


#include "wnlib.h"


EXTERN void wn_print_vect(FLOAT vect[],int len);
EXTERN void wn_enter_vect(FLOAT vect[],int len);
EXTERN void wn_random_vect(FLOAT vect[],int len);
EXTERN void wn_zero_vect(FLOAT vect[],int len);

EXTERN void wn_make_vect(FLOAT **pvect,int len);
EXTERN void wn_free_vect(FLOAT *vect,int len);

EXTERN void wn_copy_vect(FLOAT to_vect[],FLOAT from_vect[],int len);

EXTERN FLOAT wn_dot_vects(FLOAT *vect1,FLOAT *vect2,int len);
EXTERN FLOAT wn_norm2_vect(FLOAT *vect,int len);
EXTERN FLOAT wn_norm_vect(FLOAT *vect,int len);
EXTERN void wn_unit_vect(FLOAT vect[],int len);
EXTERN FLOAT wn_dist2_vect(FLOAT v1[],FLOAT v2[],int len);
EXTERN FLOAT wn_dist_vect(FLOAT v1[],FLOAT v2[],int len);

EXTERN 
void wn_add_scaled_vect(FLOAT *to_vect,FLOAT *from_vect,FLOAT scalar,
			int len);
EXTERN
void wn_add_vect_and_scaled_vect(FLOAT *out,
				 FLOAT *v1,FLOAT *v2,FLOAT s2,
			         int len);
EXTERN void wn_add_scaled_vects
(
  FLOAT *out,
  FLOAT *v1,
  FLOAT s1,
  FLOAT *v2,
  FLOAT s2,
  int len
);
EXTERN void wn_add_3_scaled_vects
(
  FLOAT *out,
  FLOAT *v1,
  FLOAT s1,
  FLOAT *v2,
  FLOAT s2,
  FLOAT *v3,
  FLOAT s3,
  int len
);
EXTERN void wn_subtract_vect
(
  FLOAT *to_vect,
  FLOAT *from_vect,
  int len
);
EXTERN void wn_scale_vect(FLOAT *vect,FLOAT scalar,int len);

EXTERN void wn_multiply_vect_by_vect(FLOAT *v1, FLOAT *v2, int len);
EXTERN void wn_divide_vect_by_vect(FLOAT *v1, FLOAT *v2, int len);
EXTERN void wn_add_scaled_vects_and_dot_and_norm
(
  FLOAT *out,
  FLOAT *pnorm2_out,
  FLOAT *pdot_v1_out,
  FLOAT *v1,
  FLOAT s1,
  FLOAT *v2,
  FLOAT s2,
  int len
);

#endif

